import numpy 
import time

start = time.time()
############## Unary Selection Operators ################
# Unary Selection Operators in terms of the policy operators E_1, E_2 and \minop
Sb_b = 'x \minop \diamond\sim(x) \minop \diamond\sim\diamond\sim(x)'
S0_b = 'x \minop \diamond\sim(x) \minop \diamond\sim\diamond\sim(x)'
S1_b = 'x \minop \diamond\sim(x) \minop \diamond\sim\diamond\sim(x)'
St_b = 'x \minop \diamond\sim(x) \minop \diamond\sim\diamond\sim(x)'
Sb_0 = '\diamond(x) \minop \sim\diamond\sim\diamond\sim(x) \minop \sim\diamond\sim\diamond(x)'
S0_0 = 'x \minop \sim(x) \minop \sim\diamond\sim(x)'
S1_0 = '\diamond\sim\diamond\sim(x) \minop \sim\diamond\sim\diamond\sim(x) \minop \diamond(x)'
St_0 = '\diamond\sim(x) \minop \sim\diamond\sim(x) \minop \diamond\diamond\sim\diamond(x)'
Sb_1 = '\diamond\sim\diamond(x) \minop \sim\diamond\sim\diamond(x) \minop \diamond\diamond(x)'
S0_1 = '\diamond(x) \minop \sim\diamond(x) \minop \diamond\sim(x)'
S1_1 = 'x \minop \sim(x) \minop \diamond\diamond\sim\diamond(x)'
St_1 = '\diamond\sim\diamond\sim(x) \minop \sim\diamond\sim\diamond\sim(x) \minop \diamond\diamond\sim(x)'
Sb_t = '\sim\diamond\sim(x) \minop \sim\diamond\sim\diamond\sim(x) \minop \sim(x)'
S0_t = '\diamond\sim\diamond\sim(x) \minop \diamond\sim\diamond(x) \minop \diamond\diamond(x)'
S1_t = '\diamond(x) \minop \diamond\sim(x) \minop \diamond\sim\diamond\diamond\sim\diamond(x)'
St_t = 'x \minop \sim\diamond(x) \minop \sim\diamond\sim\diamond(x)'

############## Functions ################

def UnarySelectionOpsToPolicyOps( selop, iterate):
	if selop == 'Sb_b':
		temp = 'd_' + str(iterate) + ' \diamond\sim(d_' + str(iterate) +') \minop \diamond\sim\diamond\sim(d_' + str(iterate) +')'
		return temp
	elif selop == 'S0_b':
		temp = 'd_' + str(iterate) + ' \diamond\sim(d_' + str(iterate) +') \minop \diamond\sim\diamond\sim(d_' + str(iterate) +')'
		return temp
	elif selop == 'S1_b':
		temp = 'd_' + str(iterate) + ' \diamond\sim(d_' + str(iterate) +') \minop \diamond\sim\diamond\sim(d_' + str(iterate) +')'
		return temp
	elif selop == 'St_b':
		temp = 'd_' + str(iterate) + ' \diamond\sim(d_' + str(iterate) +') \minop \diamond\sim\diamond\sim(d_' + str(iterate) +')'
		return temp
	elif selop == 'Sb_0':
		temp = '\diamond(d_' + str(iterate) + ') \minop \sim\diamond\sim\diamond\sim(d_' + str(iterate) +') \minop \sim\diamond\sim\diamond(d_' + str(iterate) +')'
		return temp
	elif selop == 'S0_0':
		temp = 'd_' + str(iterate) + ' \minop \sim(d_' + str(iterate) +') \minop \sim\diamond\sim(d_' + str(iterate) +')'
		return temp
	elif selop == 'S1_0':
		temp = '\diamond\sim\diamond\sim(d_' + str(iterate) + ') \minop \sim\diamond\sim\diamond\sim(d_' + str(iterate) +') \minop \diamond(d_' + str(iterate) +')'
		return temp
	elif selop == 'St_0':
		temp = '\diamond\sim(d_' + str(iterate) + ') \minop \sim\diamond\sim(d_' + str(iterate) +') \minop \diamond\diamond\sim\diamond(d_' + str(iterate) +')'
		return temp
	elif selop == 'Sb_1':
		temp = '\diamond\sim\diamond(d_' + str(iterate) + ') \minop \sim\diamond\sim\diamond(d_' + str(iterate) +') \minop \diamond\diamond(d_' + str(iterate) +')'
		return temp
	elif selop == 'S0_1':
		temp = '\diamond(d_' + str(iterate) + ') \minop \sim\diamond(d_' + str(iterate) +') \minop \diamond\sim(d_' + str(iterate) +')'
		return temp
	elif selop == 'S1_1':
		temp = 'd_' + str(iterate) + ' \minop \sim(d_' + str(iterate) +') \minop \diamond\diamond\sim\diamond(d_' + str(iterate) +')'
		return temp
	elif selop == 'St_1':
		temp = '\diamond\sim\diamond\sim(d_' + str(iterate) + ') \minop \sim\diamond\sim\diamond\sim(d_' + str(iterate) +') \minop \diamond\diamond\sim(d_' + str(iterate) +')'
		return temp
	elif selop == 'Sb_t':
		temp = '\sim\diamond\sim(d_' + str(iterate) + ') \minop \sim\diamond\sim\diamond\sim(d_' + str(iterate) +') \minop \sim(d_' + str(iterate) +')'
		return temp
	elif selop == 'S0_t':
		temp = '\diamond\sim\diamond\sim(d_' + str(iterate) + ') \minop \diamond\sim\diamond(d_' + str(iterate) +') \minop \diamond\diamond(d_' + str(iterate) +')'
		return temp
	elif selop == 'S1_t':
		temp = '\diamond(d_' + str(iterate) + ') \minop \diamond\sim(d_' + str(iterate) +') \minop \diamond\sim\diamond\diamond\sim\diamond(d_' + str(iterate) +')'
		return temp
	elif selop == 'St_t':
		temp = 'd_' + str(iterate) + ' \minop \sim\diamond(d_' + str(iterate) +') \minop \sim\diamond\sim\diamond(d_' + str(iterate) +')'
		return temp





# This function takes an array of unary selection operators as input 
# and expresses them in terms of the policy operators E_1, E_2 and \minop
def ArrayOfSelectionOpsToPolicyOps( selop, iterate ):
	selop = [w.replace('S0_0', 'd_' + str(iterate) + ' \minop E_1(d_' + str(iterate) +') \minop E_2(d_' + str(iterate) +')') for w in selop]
	selop = [w.replace('Sb_0', 'd_' + str(iterate) + ' \minop E_1(d_' + str(iterate) +') \minop E_2(d_' + str(iterate) +')') for w in selop]
	selop = [w.replace('S1_0', 'd_' + str(iterate) + ' \minop E_1(d_' + str(iterate) +') \minop E_2(d_' + str(iterate) +')') for w in selop]
	selop = [w.replace('S0_b', 'E_1(d_' + str(iterate) +') \minop E_2E_1(d_' + str(iterate) +')') for w in selop]
	selop = [w.replace('Sb_b', 'd_' + str(iterate) + ' \minop E_2(d_' + str(iterate) +')') for w in selop]
	selop = [w.replace('S1_b', 'E_1E_2(d_' + str(iterate) +') \minop E_2E_1E_2(d_' + str(iterate) +')') for w in selop]
	selop = [w.replace('S0_1', 'E_2(d_' + str(iterate) +') \minop E_1E_2(d_' + str(iterate) +')') for w in selop]
	selop = [w.replace('Sb_1', 'E_2E_1(d_' + str(iterate) +') \minop E_2E_1E_2(d_' + str(iterate) +')') for w in selop]
	selop = [w.replace('S1_1', 'd_' + str(iterate) + ' \minop E_1(d_' + str(iterate) +')') for w in selop]
	return selop

# This function probably useless
def convertNarySelectionOptoUnary( selop ):
	temp = ''
	SelectionOpLength = len(selop) 
	for i in range(SelectionOpLength - 3):
		if i == SelectionOpLength - 4:
			temp = temp + 'S' + selop[i+1] + "_" + selop[-1]
		else:
			temp = temp + 'S' + selop[i+1] + "_" + selop[-1] + ' ' + '\minop' + ' '
		print temp
	return temp


# In this function, we take a nary selection operator Sabc....n_X
# and convert it into unary selection operators. We iterate over the length
# of the selop -3 to remove _X from the construction. 
# tempString starts at i+1 to ignore S, and we add _X via "_" + selop[-1] 
def convertNarySelectionOptoUnary2( selop ):
	temp = []
	SelectionOpLength = len(selop) 
	for i in range(SelectionOpLength - 3):
		tempString ='S' + selop[i+1] + "_" + selop[-1]
		temp.append(tempString)
	return temp

# This function converts the numerical rows into selection opertators
def convertPolicyTableToSelctionOps( policy ):
	tempString = ''
	rows = len(policy)
	cols = len(policy[0])
	temp = []
	for i in range(rows-1):
		for j in range(cols-1):
			tempString = tempString + str(policy[i+1][j])
		tempSelop = 'S' + tempString + '_' + str(policy[i+1][j+1])
		temp.append(tempSelop)
		tempString = ''
	return temp 

############## Tests ################


#print 'First Selection operator test, converting S110_1 to S1_1, S1_1 and S0_1'
#NarySelectionOp = convertNarySelectionOptoUnary2('S110_1')
#print NarySelectionOp
#print 'Converting S1_1, S_1 and S0_1 into their composition of operators'
#NarySelectionOp = ArrayOfSelectionOpsToPolicyOps(NarySelectionOp)
#print NarySelectionOp
#print NarySelectionOp[1]


############## Core Code ################

# This is the policy decision table we will convert into normal form
print
PolicyArray = [['p_1','p_2','p_3','p_4','P'],['0','t','b','1','b'],['b','t','0','b','b'],['1','0','1','1','b'],['b','b','b','1','b'],['t','1','0','t','0'],['1','t','0','0','1'],['t','0','b','b','b'],['b','0','t','0','1'],['0','1','1','t','b'],['0','1','0','0','b']]# Saving the Policy decision table into a txt file ready for input in latex
numpy.savetxt("Policy_table_4_values.txt", PolicyArray, fmt='%s', delimiter=' & ', newline=' \\\\\n')


rows = len(PolicyArray)
cols = len(PolicyArray[0])

# Outputting the policy decision table
print 'We are converting the following Policy Table into Selection Operators'
for i in range(rows):
	for j in range(cols):
		print PolicyArray[i][j],
	print

print


# Converting the policy decision table into n-ary selection operators combined with \maxop
PolicyArrayAsSelectionOps = convertPolicyTableToSelctionOps(PolicyArray)
print 'This policy array is specified by the following combination of selection operators:'
tempStringSelop = ''
for i in range(len(PolicyArrayAsSelectionOps)):
	if i == len(PolicyArrayAsSelectionOps) -1 :
		tempStringSelop = tempStringSelop + PolicyArrayAsSelectionOps[i]
	else:
		tempStringSelop = tempStringSelop + PolicyArrayAsSelectionOps[i] + ' \maxop '
print tempStringSelop
print

# Converting each n-ary selection operator into their composition of unary selection operators
UnarySelectionOpsArray = []
for i in range(len(PolicyArrayAsSelectionOps)):
	temp = convertNarySelectionOptoUnary2(PolicyArrayAsSelectionOps[i])
	UnarySelectionOpsArray.append(temp)

temp1 = ''
temp2 = ''
for i in range(len(UnarySelectionOpsArray)):
	for j in range(len(UnarySelectionOpsArray[0])):
		if j == len(UnarySelectionOpsArray) -2 :
			temp1 = temp1 + UnarySelectionOpsArray[i][j]
		else:
			temp1 = temp1 + UnarySelectionOpsArray[i][j] + ' \minop '
	if i == len(UnarySelectionOpsArray) -1:
		temp2 = temp2 + '(' + temp1 + ')'
	else:
		temp2 = temp2 + '(' + temp1 + ') \maxop '
	temp1 = ''
print 'This can be expanded to an expression consisting of unary selection operators:'
print temp2
print

UnRows = len(UnarySelectionOpsArray)
UnCols = len(UnarySelectionOpsArray[0])



for i in range(UnRows):
	for j in range(UnCols):
		UnarySelectionOpsArray[i][j] =  UnarySelectionOpsToPolicyOps(UnarySelectionOpsArray[i][j],j+1)

#print UnarySelectionOpsArray
# Converting each unary selection operator to their equivalent expression comprising of E_1,E_2 and \minop
#for i in range(UnRows):
#	UnarySelectionOpsArray[i] = ArrayOfSelectionOpsToPolicyOps(UnarySelectionOpsArray[i],i)

print UnarySelectionOpsArray

temp1 = ''
temp2 = ''
for i in range(len(UnarySelectionOpsArray)):
	for j in range(len(UnarySelectionOpsArray[0])):
		if j == len(UnarySelectionOpsArray) -1 :
			temp1 = temp1 + UnarySelectionOpsArray[i][j]
		else:
			temp1 = temp1 + UnarySelectionOpsArray[i][j] + ' \minop '
	if i == len(UnarySelectionOpsArray) -1:
		temp2 = temp2 + '(' + temp1 + ')'
	else:
		temp2 = temp2 + '(' + temp1 + ') \maxop \\\\'
	temp1 = ''
print 'Converting the unary selection operators to expressions comprising of E_1, E_2 and \minop:'
print temp2

# Saving the unary selection operators output in a text file ready for input into latex
with open('Unary_selection_operators_4_values.txt', 'w') as f:
    f.write(temp2)


print 'Blank Line'

end = time.time()
runtime = end - start
print 'Time to execute:' + str(runtime)